
open Hashset

let hash_string s =
  let n = String.length s in
  let rec hash h i =
    if i = n then h else hash (19 * h + Char.code s.[i]) (i+1) in
  hash 0 0

let eq_string s1 s2 =
  s1 = s2

let () =
  Format.printf "Je teste Hashset avec deux premières fonctions.@.";
  let t = create 10 in
  assert (size t = 0);
  add hash_string eq_string t "foo";
  assert (size t = 1);
  assert (find hash_string eq_string t "foo" = Some "foo");
  add hash_string eq_string t "foo";
  assert (size t = 1);
  add hash_string eq_string t "bar";
  assert (size t = 2);
  let t = create 17 in
  assert (size t = 0);
  for k = 1 to 26 do
    add hash_string eq_string t (String.make k (Char.chr (64 + k)));
    assert (size t = k)
  done;
  assert (find hash_string eq_string t "A" = Some "A");
  assert (find hash_string eq_string t "AA" = None);
  assert (find hash_string eq_string t "BB" = Some "BB");
  Format.printf "OK@."

let hash_string s =
  let n = min 8 (String.length s) in
  let rec hash h i =
    if i = n then h else hash (19 * h + Char.code s.[i]) (i+1) in
  hash 0 0 land max_int

let eq_string s1 s2 =
  let truncate s = if String.length s > 8 then String.sub s 0 8 else s in
  truncate s1 = truncate s2

let () =
  Format.printf "Je teste maintenant Hashset avec deux autres fonctions.@.";
  let t = create 10 in
  assert (size t = 0);
  add hash_string eq_string t "my_variable_x";
  assert (size t = 1);
  assert (find hash_string eq_string t "my_variable_x" = Some "my_variable_x");
  add hash_string eq_string t "my_variable_y";
  assert (size t = 1);
  assert (find hash_string eq_string t "my_variable_y" = Some "my_variable_x");
  let t = create 17 in
  assert (size t = 0);
  for k = 1 to 26 do
    add hash_string eq_string t (String.make k (Char.chr (64 + k)));
    assert (size t = k)
  done;
  assert (find hash_string eq_string t "A" = Some "A");
  assert (find hash_string eq_string t "AA" = None);
  assert (find hash_string eq_string t "AA" = None);
  assert (find hash_string eq_string t "HHHHHHHH" = Some "HHHHHHHH");
  assert (find hash_string eq_string t "HHHHHHHHX" = Some "HHHHHHHH");
  assert (find hash_string eq_string t "IIIIIIIIX" = Some "IIIIIIIII");
  Format.printf "OK@.";
  Format.printf "Tous les tests sont passés avec succès.@."




