
open Hashset2

let hash_string s =
  let n = String.length s in
  let rec hash h i =
    if i = n then h else hash (19 * h + Char.code s.[i]) (i+1) in
  hash 0 0 land max_int (* garantit un résultat >= 0 *)

let eq_string s1 s2 =
  s1 = s2

let () =
  let t = create hash_string eq_string 10 in
  assert (size t = 0);
  add t "foo";
  assert (size t = 1);
  assert (find t "foo" = Some "foo");
  add t "foo";
  assert (size t = 1);
  add t "bar";
  assert (size t = 2);
  let t = create hash_string eq_string 17 in
  assert (size t = 0);
  for k = 1 to 26 do
    add t (String.make k (Char.chr (64 + k)));
    assert (size t = k)
  done;
  assert (find t "A" = Some "A");
  assert (find t "AA" = None);
  assert (find t "BB" = Some "BB");
  ()

let hash_string s =
  let n = min 8 (String.length s) in
  let rec hash h i =
    if i = n then h else hash (19 * h + Char.code s.[i]) (i+1) in
  hash 0 0 land max_int

let eq_string s1 s2 =
  let truncate s = if String.length s > 8 then String.sub s 0 8 else s in
  truncate s1 = truncate s2

let () =
  let t = create hash_string eq_string 10 in
  assert (size t = 0);
  add t "my_variable_x";
  assert (size t = 1);
  assert (find t "my_variable_x" = Some "my_variable_x");
  add t "my_variable_y";
  assert (size t = 1);
  assert (find t "my_variable_y" = Some "my_variable_x");
  let t = create hash_string eq_string 17 in
  assert (size t = 0);
  for k = 1 to 26 do
    add t (String.make k (Char.chr (64 + k)));
    assert (size t = k)
  done;
  assert (find t "A" = Some "A");
  assert (find t "AA" = None);
  assert (find t "AA" = None);
  assert (find t "HHHHHHHH" = Some "HHHHHHHH");
  assert (find t "HHHHHHHHX" = Some "HHHHHHHH");
  assert (find t "IIIIIIIIX" = Some "IIIIIIIII");
  ()



