
open Tree

let rec perfect = function
  | 0 -> E
  | n -> N (perfect (n-1), n, perfect (n-1))

let () =
  assert (mem_size (perfect 0) = 0);
  assert (mem_size (perfect 1) = 1);
  assert (mem_size (perfect 2) = 3);
  assert (mem_size (perfect 3) = 7);
  assert (mem_size (perfect 4) = 15);
  ()

let rec perfect2 = function
  | 0 -> E
  | n -> let t = perfect2 (n-1) in N (t, n, t)

let () =
  assert (mem_size (perfect2 0) = 0);
  assert (mem_size (perfect2 1) = 1);
  assert (mem_size (perfect2 2) = 2);
  assert (mem_size (perfect2 3) = 3);
  assert (mem_size (perfect2 4) = 4);
  ()

let () =
  assert (mem_size (share (perfect 0)) = 0);
  assert (mem_size (share (perfect 1)) = 1);
  assert (mem_size (share (perfect 2)) = 2);
  assert (mem_size (share (perfect 3)) = 3);
  assert (mem_size (share (perfect 4)) = 4);
  ()

let () =
  assert (mem_size (share2 (perfect 0)) = 0);
  assert (mem_size (share2 (perfect 1)) = 1);
  assert (mem_size (share2 (perfect 2)) = 2);
  assert (mem_size (share2 (perfect 3)) = 3);
  assert (mem_size (share2 (perfect 4)) = 4);
  ()
